/* Matthew Phillips mephilli 20066500 CS488 A5
 *
 * Copyright (c) 2005 Matthew Phillips
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
/** @file battleship_model.c 
 *
 *  These files are responsible for the data structures used by the game.
 */
#include <stdlib.h>
#include <string.h>
#include "battleship_model.h"

void
battleship_model_init()
{
	static bool first_time = true;
	
	size_t p, i, j; 
	for (p = 0; p < 2; p++)
	{
		//clear grid state
		for (i = 0; i < GRID_DIM; i++)
			for (j = 0; j < GRID_DIM; j++)
				player[p].grid[i][j] = GRID_EMPTY;
		//clear grid ship
		for (i = 0; i < GRID_DIM; i++)
			for (j = 0; j < GRID_DIM; j++)
				player[p].ship_at[i][j] = NO_SHIP;
		//init ships
		for (i = 0; i < NUM_SHIPS; i++)
		{
			player[p].ship[i].down = false;
			player[p].ship[i].x = 0;
			player[p].ship[i].y = 0;
			player[p].ship[i].num_hits = 0;
			//detrmine length
			unsigned char l = 0;
			switch (i)
			{
				case CARRIER: l = CARRIER_LEN; break;
				case BATTLESHIP: l = BATTLESHIP_LEN; break;
				case DESTROYER: l = DESTROYER_LEN; break;
				case SUB: l = SUB_LEN; break;
				case PT: l = PT_LEN; break;
			}
			player[p].ship[i].length = l;
			player[p].ship[i].state = SHIP_NOT_PLACED;
		}
		player[p].num_misses = 0;
		player[p].num_hits = 0;
		player[p].num_sunk = 0;
		player[p].sel_x = 0;
		player[p].sel_y = 0;
	}

	curr_player = 0;

	if (first_time)
	{
		demo_mode = false;
		do_fog = FOG_MEDIUM;
		do_trans_animation = true;
		do_ai_animation = true;
		do_msg_animation = true;
		do_textures = true;
		
		for (i = 0; i < NUM_SHADOWS; i++)
			do_shadows[i] = true;
		do_shadows[SHADOW_FLOOR] = false;

		name_selector.enabled = false;

		game_lsys.enabled = true;
		game_lsys.type = 7;
		game_lsys.length = MIN_LSYSTEM_LENGTH;
		
		game_rocket.type = ROCKET_SIDE;
		game_rocket.show_path = false;
		game_rocket.size = 2;
		game_rocket.draw_fire = true;
		game_rocket.len = 3;
		game_rocket.width = FIRE_SKINNY;
		game_rocket.speed = 4;
		game_rocket.colour = PSYSTEM_COLOUR_ORANGE;
	
		strcpy(player[0].name, "Player 1");
		player[0].ai = AI_HUMAN;
		player[0].auto_place = false;
		player[0].fog = false;
		strcpy(player[1].name, "Player 2");
		player[1].ai = AI_HARD;
		player[1].auto_place = true;
		player[1].fog = true;
	}
	
	first_time = false;
}
