/* Matthew Phillips mephilli 20066500 CS488 A5
 *
 * Copyright (c) 2005 Matthew Phillips
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
/** @file battleship_rocket.c 
 *
 *  Responsible for the rocet.
 *
 *  In general this entire file is garbage. It should be rewritten.
 *  I have no idea what I'm donig wrong on the angle caculations but 
 *  they are just stupid.
 * 
 */
#include <math.h>

#include "battleship_model.h"
#include "battleship_rocket.h"
#include "glprimitive.h"
#include "psystem.h"

/** The orginal rocket path (including size) */
static GLdouble *path;
/** How small t is divided */
static GLdouble detail;
/** The current value of t (progress along spline) */
static GLdouble progress;
/** The points which make up the path to follow */
static GLdouble *points;
/** The current position */
static GLdouble loc[3];
/** Used to make the rocket spin, updated on each draw */
static int rot_x;
/** Used to orient the rocket */
static GLdouble rot_y;
/** Used to orient the rocket */
static GLdouble rot_z;
/** Used to orient the rocket */
static bool reverse;

/** The current point used as the first point of the spline */
static size_t curr_point;
/** How many points there are on the path */
static size_t num_points;

/** True when the rocket has reached the end of the path */
static bool stopped;

/** The size of the rocket */
static GLdouble rocket_size;

/** Particle system used for fire */
struct psystem fire;

/** Figures out how the rocket needs to be rotated to point in
 *  the direction it is moving 
 *  @param x The change in x
 *  @param y The change in y
 *  @param z The change in z
 */
static void calc_rotation(GLdouble x, GLdouble y, GLdouble z)
{
	GLdouble h = sqrt(x*x + y*y);
	GLdouble h2 = sqrt(z*z + h*h);
	
	if (fabs(h) < 0.001)
	{
		//Don't change, dah!
	}
	else
	{
		reverse = false;
		GLdouble rz = 0;
		GLdouble ry = 0;
		GLdouble nz = 1;
		GLdouble ny = 1;
		
		if (x < 0 && y < 0 && z > 0)
			ry = 180;
		else if (x > 0 && y < 0 && z > 0)
		{
			nz = -1;
			ny = -1;
		}
		else if (x < 0 && y > 0 && z <= 0)
		{
			nz = -1;
			ny = -1;
			reverse = true;
		}
		else if (x < 0 && y < 0)
			rz = 180;
		else if (z > 0 && x > 0)
			ry -= 90;
		else if (z < 0 && x < 0)
			ry = 90;
		else if (x < 0 && z > 0)
			ry = 180;
		else if (y > 0 && z > 0)
			ry = -90;
		else if (y < 0 && z > 0)
			ry = 180;
		else if (y < 0 && z <= 0)
		{
			x = fabs(x); y = fabs(y); z = fabs(z);
			rot_z = -acos(x/h)*180/M_PI;
			rot_y = acos(h/h2)*180/M_PI;
			return;
		}

		x = fabs(x); y = fabs(y); z = fabs(z);
		rot_z = nz*acos(x/h)*180/M_PI + rz;
		rot_y = ny*acos(h/h2)*180/M_PI + ry;
	}
}

/** Calculates the next position for the rocket using quadric spline
 * 	@param curr The base point
 * 	@param comp 0 = x, 1 = y, 2 = z
 * 	@param t The distance along the spline
 *
 * 	@return Returns an interpolated point
 */
static GLdouble calc_point(size_t curr, size_t comp, GLdouble t)
{
	//return points[curr*3 + comp]*(1.0 - t) + points[(curr + 1)*3 + comp]*t;
	return points[(curr + 0)*3 + comp]*(1.0 - 2*t + t*t) 
		 + points[(curr + 1)*3 + comp]*(2*t - 2*t*t) 
		 + points[(curr + 2)*3 + comp]*t*t;
}

void
battleship_rocket_init()
{
	rocket_size = 0.2;
	detail = 0;
	progress = 0;
	points = NULL;
	loc[0] = 0;
	loc[1] = 0;
	loc[2] = 0;
	curr_point = 0;
	num_points = 0;
	stopped = true;
	
	battleship_rocket_update();
	//psystem_init(&fire, rocket_size - 0.05, rocket_size/2.0, rocket_size*6);
}

void battleship_rocket_reset()
{
	stopped = false;

	if (points)
	{
		loc[0] = points[0];
		loc[1] = points[1];
		loc[2] = points[2];
		//calculate an inital rotation
		if (num_points > 1)
		{
			calc_rotation(
				points[3]-points[0], points[4]-points[1], points[5]-points[2]
				);
		}
	}
	else
	{
		loc[0] = 0;
		loc[1] = 0;
		loc[2] = 0;
		rot_y = 0;
		rot_z = 0;
	}
	
	curr_point = 0;
	progress = detail;
	rot_x = 0;
	//psystem_reset(&fire);
}

bool battleship_rocket_stopped()
{
	return stopped;
}


bool
battleship_rocket_move()
{
	//wrap around
	if (curr_point >= num_points - 2 || !points)
	{
		stopped = true;
		return false;
	}

	//figure out point
	GLdouble old_loc[3];
	size_t i;
	for (i = 0; i < 3; i++)
	{
		old_loc[i] = loc[i];
		loc[i] = calc_point(curr_point, i, progress);
	}
	
	//Find current direction vector
	GLdouble x = loc[0] - old_loc[0]; 
	GLdouble y = loc[1] - old_loc[1]; 
	GLdouble z = loc[2] - old_loc[2];
	
	calc_rotation(x, y, z);
	//DPRINT("%g %g %g - %g %g\n", x, y, z, rot_y, rot_z);
	
	progress += detail;
	if (progress > 1)
	{
		progress = 0;
		curr_point += 2;
	}
	
	return true;
}

void
battleship_rocket_draw(bool show_path)
{
	static const GLfloat diff_w[] = {1.0, 1.0, 1.0, 1.0};
	static const GLfloat spec_w[] = {0.1, 0.1, 0.1, 1.0};
	static const GLfloat shinny_w = 1;
	static const GLfloat diff_r[] = {1.0, 0.0, 0.0, 1.0};
	static const GLfloat spec_r[] = {0.1, 0.1, 0.1, 1.0};
	static const GLfloat shinny_r = 1;
	
	glMaterialfv(GL_FRONT, GL_DIFFUSE, diff_w);
    glMaterialfv(GL_FRONT, GL_SPECULAR, spec_w);
	glMaterialf(GL_FRONT, GL_SHININESS, shinny_w);
	
	if (show_path)
	{
		glLineWidth(2.0);
		glBegin(GL_LINES);
			size_t c = 0;
			GLdouble p = 0;
			while (true)
			{
				if (c >= num_points - 2 || !points)
					break;

				GLdouble l[3];
				size_t i;
				for (i = 0; i < 3; i++)
				{
					l[i] = calc_point(c, i, p);
				}
				glVertex3d(l[0], l[1], l[2]);

				p += detail;
				if (p > 1)
				{
					p = 0;
					c += 2;
				}
			}
		glEnd();	

		//Draw Linear path
		glBegin(GL_LINES);
			size_t i;
			for (i = 0; i < num_points - 1; i++)
			{
				glVertex3d(points[i*3], points[i*3+1], points[i*3+2]);
				glVertex3d(points[i*3 + 3], points[i*3+ 4], points[i*3 + 5]);
			}
		glEnd();
	}

	glPushMatrix();
		//Tranlate to the point and center the rocket
		glTranslated(loc[0], loc[1], loc[2]);

		//Orient correctly
		glRotated(rot_z, 0.0, 0.0, 1.0);
		glRotated(rot_y, 0.0, 1.0, 0.0);
		if (!reverse)
			glRotated(-90, 0.0, 1.0, 0.0);
		else
			glRotated(90, 0.0, 1.0, 0.0);
		
		//Fire!!!
		if (game_rocket.draw_fire)
		{
			glPushMatrix();
				glTranslated(0.0, 0.0, rocket_size*7.5);
				psystem_advance(&fire);
				psystem_draw(&fire);
			glPopMatrix();
		}

		//spin
		rot_x = (rot_x + 5) % 360;
		glRotated((GLdouble) rot_x, 0.0, 0.0, 1.0);
		
		//The nouse
		glPushMatrix();
			glMaterialfv(GL_FRONT, GL_DIFFUSE, diff_r);
			glMaterialfv(GL_FRONT, GL_SPECULAR, spec_r);
			glMaterialf(GL_FRONT, GL_SHININESS, shinny_r);
			glScaled(1.0, 1.0, 2.5);
			glprimitive_sphere(rocket_size);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, diff_w);
			glMaterialfv(GL_FRONT, GL_SPECULAR, spec_w);
			glMaterialf(GL_FRONT, GL_SHININESS, shinny_w);
		glPopMatrix();
		//Body
		glprimitive_cylinder(rocket_size, 8*rocket_size);
		glTranslated(0.0, 0.0, 8*rocket_size);
		glprimitive_cone(rocket_size, rocket_size/2.0, -rocket_size*8);
		
		//Wings
		size_t i = 0; 
		for (i = 0; i < 4; i++)
		{
			if (i % 2 == 0)
			{
				glMaterialfv(GL_FRONT, GL_DIFFUSE, diff_r);
				glMaterialfv(GL_FRONT, GL_SPECULAR, spec_r);
				glMaterialf(GL_FRONT, GL_SHININESS, shinny_r);
			}
			else
			{
				glMaterialfv(GL_FRONT, GL_DIFFUSE, diff_w);
				glMaterialfv(GL_FRONT, GL_SPECULAR, spec_w);
				glMaterialf(GL_FRONT, GL_SHININESS, shinny_w);
			}

			glBegin(GL_TRIANGLES);
				//left
				glNormal3d(0.0, 1.0, 0.0);
				glVertex3d(rocket_size, 0.0, -2*rocket_size);
				glVertex3d(rocket_size, 0.0, 0.0);
				glVertex3d(3*rocket_size, 0.0, 0.0);
			
				//right
				glNormal3d(0.0, -1.0, 0.0);
				glVertex3d(3*rocket_size, -rocket_size/5, 0.0);
				glVertex3d(rocket_size, -rocket_size/5, 0.0);
				glVertex3d(rocket_size, -rocket_size/5, -2*rocket_size);
			glEnd();
			glBegin(GL_QUADS);
				//back
				glNormal3d(0.0, 0.0, 1.0);
				glVertex3d(rocket_size, 0.0, 0.0);
				glVertex3d(rocket_size, -rocket_size/5.0, 0.0);
				glVertex3d(3*rocket_size, -rocket_size/5.0, 0.0);
				glVertex3d(3*rocket_size, 0.0, 0.0);
				//front
				glNormal3d(0.5, 0.0, -0.5);
				glVertex3d(3*rocket_size, 0.0, 0.0);
				glVertex3d(3*rocket_size, -rocket_size/5.0, 0.0);
				glVertex3d(rocket_size, -rocket_size/5.0, -2.0*rocket_size);
				glVertex3d(rocket_size, 0.0, -2.0*rocket_size);
			glEnd();	
	
			glRotated(90, 0.0, 0.0, 1.0);
		}	
	glPopMatrix();	
}

void
battleship_rocket_set_detail(GLdouble d)
{
	detail = d;
}

void 
battleship_rocket_set_path(GLdouble *p)
{
	path = p;
	points = p;
	num_points = 0;
	if (points)
	{
		num_points = points[0];
		++points;
	}

	battleship_rocket_reset();
}

GLdouble *
battleship_rocket_get_path()
{
	return path;
}

void
battleship_rocket_update()
{
	rocket_size = game_rocket.size/10.0;
	
	GLdouble w = 1.0;
	switch (game_rocket.width)
	{
		case FIRE_SKINNY: w = 0.5; break;
		case FIRE_EQUAL: w = 1.0; break;
		case FIRE_WIDE: w = 4.0; break;
	}
	
	psystem_init(&fire, 
					rocket_size - 0.05, 
					rocket_size*w, 
					rocket_size*((GLdouble) game_rocket.len)*2.0,
					game_rocket.colour
				);
}
