/* Matthew Phillips mephilli 20066500 CS488 A5
 *
 * Copyright (c) 2005 Matthew Phillips
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
/** @file battleship_rocket.h 
 *
 *  Resposible for the rocket
 */
#ifndef BATTLEHIP_ROCKET_H
#define BATTLEHIP_ROCKET_H

#ifdef WIN32
#include <windows.h>
#endif /* WIN32 */

#include <GL/gl.h>
#include <GL/glu.h>

#ifdef WIN32
#include "glui.h"
#endif /* WIN32 */

#include <stdbool.h>

/** Inititlizes the rocket */
void
battleship_rocket_init();

/** Puts the rocet back at the start of the path */
void battleship_rocket_reset();

/** Returns true if the rocket is at the end of its path */
bool 
battleship_rocket_stopped();

/** Causes the rocket to move 
 *
 * 	Returns true when the rocket has reached the end of its path
 */
bool 
battleship_rocket_move();

/** Draws the rocket
 *  @param show_path Set to true to draw the rockets path as well as the rocket
 */
void 
battleship_rocket_draw(bool show_path);

/** Sets the detail of the path (how many intermidiate points are used)
 *  @param speed A number between 0 and 1. 1 = Fastest
 */
void 
battleship_rocket_set_detail(GLdouble speed);

/** Sets the rockets path 
 *  @param points 
 *  			 An array containing the points the rocket should fly through
 *  			 in groups of 3 (x, y, z). The first element of the array
 *  			 should represent the number of triples in the array.
 *  			 So an array with 3 points would by 3 x y z x y z x y z
 */
void 
battleship_rocket_set_path(GLdouble *points);

/** Returns the rockte path */
GLdouble *
battleship_rocket_get_path();

/** Turns fire on/off 
 *  @param on Ture to draw fire
 **/
void
battleship_rocket_set_fire(bool on);

/** Updates some rocket paramaters based on current game value */
void
battleship_rocket_update();

#endif /* BATTLEHIP_ROCKET_H */
