/* Matthew Phillips mephilli 20066500 CS488 A5
 *
 * Copyright (c) 2005 Matthew Phillips
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
/** @file battleship_sound.h
 *
 *  Takes care of sound stuff
 */
#ifndef BATTLEHIP_SOUND_H
#define BATTLEHIP_SOUND_H

#include <stdbool.h>

/** Ture to enable sound */
bool do_sound;

/** What sounds are available */
enum battleship_sound
{
	BATTLESHIP_SOUND_MISS,
	BATTLESHIP_SOUND_HIT,
	BATTLESHIP_SOUND_SUNK,
	BATTLESHIP_SOUND_WIN,
};

/** Initilizes the sound system */
void
battleship_sound_init();

/** Plays the given sound 
 *  @param id The sound id
 */
void
battleship_sound_play(enum battleship_sound id);

/** Stops all current sounds */
void
battleship_sound_stop();

#endif /* BATTLEHIP_SOUND_H */
