/* Matthew Phillips mephilli 20066500 CS488 A5
 *
 * Copyright (c) 2005 Matthew Phillips
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
/** @file perlin.h 
 *
 *  A perlin noise generator  
 */
#ifndef PERLIN_H
#define PERLIN_H

/** Struct to store parameters to perlin noise generator */
struct perlin
{
	/** The frequncy */
	double freq;
	/** The persistance */
	double pers;
	/** The number of octaves */
	unsigned int octaves;
};

/** Seeds the perlin random generator.
 *  @param s Seed value
 */
inline void sperlin(int s);

/** Returns a 2D perlin noise value corrisponding to the coordinates x, y
 *  @param p Perlin structure describing perlin parameters
 *  @param x x value
 *  @param y y value
 *  @return Returns a perlin value for x,y
 * */
double perlin2D(struct perlin p, int x, int y);
#endif /* GL_PRIMITIVE_H */
